--[[

"What Killed My Grounding Totem"
	-Written by noob

This Addon is called What Killed My Grounding Totem.
This addon is intended to inform you as to what killed your grounding totem,
as well as provide a statistical chart based on what has killed your totem, and how many times.
This is for those shamans who want to know what killed their totems more often than not.
This mod is written by Robert Peiers.
This is version .01 (Alpha)

]]--

local addonName, addon = ...	-- "WhatKilledMyGoundingTotem", {}

local playerGUID = UnitGUID("player")

local eventFrame = CreateFrame("Frame")
eventFrame:SetScript("OnEvent", function(self, event, ...)
	if addon[event] then
			addon[event](addon, event, ...)
	end
end)

function addon:RegisterEvent(event)
	eventFrame:RegisterEvent(event)
end

function addon:UnRegisterEvent(event)
	eventFrame:UnregisterEvent(event)
end

addon:RegisterEvent("PLAYER_ENTERING_WORLD")

function addon:PLAYER_ENTERING_WORLD(event, ...)	--OnEnable
--	print(addonName, "loaded")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

local watchEvents = {
	["UNIT_DIED"] = true,
	["SPELL_DAMAGE"] = true,
	["SPELL_SUMMON"] = true, 
	}
	
function addon:COMBAT_LOG_EVENT_UNFILTERED(event, timestamp, cEvent, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellId, ...)
	if watchEvents[cEvent] then
		if cEvent == "SPELL_SUMMON" and spellId == 8177 and sourceGUID == playerGUID then
			--print("sourceGUID:", sourceGUID, "destName", destName, "spellId", ( GetSpellInfo(spellId)) )
			self.guid = destGUID
		elseif cEvent == "SPELL_DAMAGE" and destGUID == self.guid then
			local spellName = ...
			self.spell, self.name = spellName, sourceName
			--print("the self.spell is:", self.spell, "the self.name is:", self.name)
		elseif cEvent == "UNIT_DIED" then
			if destGUID == self.guid and self.spell and self.name then
				print( ("%s killed Grounding Totem with %s!"):format(self.name, self.spell) )
				self.spell, self.name, self.guid = nil, nil, nil
			end
		end
	end
end

